

PROGRAM ERRORSERCH;

(* programma raspe~atki slow tekstowogo fajla,
   kotorye otsutstwu`t w sloware *)

CONST
  WORDLENGTH = 20;   (* maks. dlina slowa *)
  TABLELENGTH= 500;  (* maks. razmer tablicy wywodimyh na pe~atx slow *)

TYPE
  TYPWORD    = ARRAY[1..WORDLENGTH] OF CHAR;   (* tip slowa *)
  RUSSLETTERS= SET OF '`'..'~';           (* mnovestwo russkih bukw *)
  POINT      = ^TYPSTRING;	          (* ukazatelx na stroku *)
  TYPSTRING  = RECORD		          (* stroka slowarq *)
		 LEFT,RIGHT :POINT;       (* lewaq i prawaq ssylki *)
		 WORD       :TYPWORD	  (* slowo *)
	       END;
  TYPTREE    = ARRAY['`'..'~'] OF POINT;  (* derewo slow, sodervit po
					     odnomu podderewu dlq kavdoj
						     bukwy *)
  TYPLINE    = RECORD			   (* stroka tablicy *)
		 WORD    : TYPWORD;
		 COUNTER : INTEGER	   (* s~et~ik *)
	       END;
  TYPTABLE   = ARRAY[1..TABLELENGTH] OF TYPLINE;

VAR
  TRACKWORD           : TYPWORD;	    (* sled. slowo *)
  INPFNAME            : TYPWORD;	    (* imq whodnogo fajla *)
  OUF,INPF            : TEXT;		    (* identifikatory fajlow *)
  I                   : INTEGER;            (* s~et~ik bukw w slowe *)
  LENFIL	      : INTEGER;	    (* razmer fajla *)
  LETTERS             : RUSSLETTERS;	    (* russkie bukwy *)
  TREEWORD            : TYPTREE;	    (* derewo slow *)
  RESULT              : POINT;		    (* ssylka na uzel derewa *)
  FIND                : BOOLEAN;	    (* flag odnokorennogo slowa *)
  TABLE               : TYPTABLE;	    (* tablica wywodimyh slow *)
  K,J                 : 1..TABLELENGTH;     (* s~et~iki strok w tablice *)
  ANSWER	      : CHAR; 		    (* 'Y' libo 'N' *)


PROCEDURE NILTREE;
(* iniciirowanie derewa *)
VAR
  K :CHAR;

BEGIN
  FOR K:='`' TO '~' DO
    TREEWORD[K]:=NIL
END;


PROCEDURE ASSIGN (STRING :TYPWORD; WORD :TYPWORD);

VAR
  K : INTEGER;	  (* ~islo odinakowyh bukw *)

  PROCEDURE EXCLUDEWORD (STRING :TYPWORD; WORD :TYPWORD);
			 (* slowo iz slowarq i slowo iz teksta *)

  (* procedura prowerki na odnokorennoe slowo			   
     (po ~islu odinakowyh bukw i dline slowa) *)
    BEGIN
      K:=K+1;
      IF STRING[K]=WORD[K]
	THEN
	  CASE K OF
	    3 : IF (I<4) OR (I>6)
		  THEN
		    EXCLUDEWORD(STRING,WORD);
	    4 : IF (I<5) OR (I>7)
		  THEN
		    EXCLUDEWORD(STRING,WORD);
	    5 : ;
	    ELSE
	      EXCLUDEWORD(STRING,WORD)
	 END
       ELSE
	 FIND:=FALSE
    END;

BEGIN
  K:=1;
  FIND:=TRUE;
  EXCLUDEWORD(STRING,WORD)
END;

	      
PROCEDURE CREATETREE (VAR WTREE :TYPTREE);
(* postroenie derewa *)

VAR
  VOCWORD :TYPWORD;    (* slowo iz slowarq *)
  INPFV   :TEXT;       (* identifikator fajla-slowarq *)


  PROCEDURE CREATESTRING (VAR TREE :POINT; STRING :TYPWORD);

  BEGIN
    IF TREE=NIL
      THEN
	BEGIN
	  NEW(TREE);
	  WITH TREE^ DO
	    BEGIN
	      WORD:=STRING;
	      LEFT:=NIL;
	      RIGHT:=NIL
	    END
	END
      ELSE
	WITH TREE^ DO
	  IF STRING<WORD
	    THEN
	      CREATESTRING(LEFT,STRING)
	    ELSE
	      IF STRING>WORD
		THEN
		  CREATESTRING(RIGHT,STRING)
  END;

BEGIN
  REPEAT
    WRITE('imq fajla-slowarq? ');
    READLN(INPFNAME);
    RESET(INPFV,INPFNAME,'DAT',LENFIL);
    IF LENFIL=-1
      THEN
	WRITELN('fajl   ',INPFNAME,'ne najden')
  UNTIL LENFIL>0;
  REPEAT                             (* s~itywanie slow iz slowarq i *)  
    READLN(INPFV,VOCWORD);	     (*            postroenie derewa *)
    CREATESTRING(TREEWORD[VOCWORD[1]],VOCWORD);
    IF EOLN(INPFV) aND NOT EOF(INPFV) 
      THEN READLN(INPFV)
  UNTIL EOF(INPFV)
END;


PROCEDURE READWORD (VAR WORD :TYPWORD);
(* s~itywanie slowa iz teksta *)

VAR
  C,CH :CHAR;
  FLAGKIR	: BOOLEAN;     (* flag kirillicy *)

 PROCEDURE STORENEXTCHAR (X : CHAR);
 (* zapolnenie massiwa WORD *)

  BEGIN
	IF I<WORDLENGTH
	  THEN
	   BEGIN
	     IF NOT (X IN LETTERS) AND (ORD(X)#47B)
		THEN X := CHR(ORD(X)+ORD(' '))
		ELSE FLAGKIR := TRUE;
	     I := I+1;
	     WORD[I] := X
	   END
  END;

BEGIN
 REPEAT
  WORD:='                    ';
  I:=0;
  FLAGKIR:=FALSE;
  IF NOT EOF(INPF)
    THEN
      REPEAT		               (* s~itywanie simwolow do poqwleniq*) 
	CH:=INPF^; GET(INPF)	       (*                    perwoj bukwy *)
      UNTIL (CH >= 'A') OR EOF(INPF) OR (ORD(CH)=26);
  WHILE (CH >= 'A') AND NOT EOF(INPF) DO
    BEGIN
      STORENEXTCHAR (CH);
      CH:=INPF^; GET(INPF);
      IF ORD(CH)=47B THEN                     (* prowerka na twerdyj znak *)
	BEGIN
	  IF EOF(INPF) THEN EXIT;
	  C:=CH;
	  CH:=INPF^; GET(INPF);
	  IF (CH IN LETTERS) THEN
	    STORENEXTCHAR (C)
	END
    END
 UNTIL FLAGKIR OR EOF(INPF)
END;


FUNCTION FINDWORD (TREE :POINT; STRING :TYPWORD) : POINT;
(* poisk slowa w sloware s  
   odnokorennymi slowami *)
BEGIN
  IF TREE=NIL
    THEN
      FINDWORD:=NIL
    ELSE
      WITH TREE^ DO
	IF STRING<WORD
          THEN
            FINDWORD:=FINDWORD(LEFT,STRING) 
	  ELSE
            IF STRING>WORD
	      THEN
		FINDWORD:=FINDWORD(RIGHT,STRING)
	      ELSE
                FINDWORD:=TREE
END;


FUNCTION ROOTFINDWORD (TREE :POINT; STRING :TYPWORD) : POINT;
(* poisk slowa w sloware bez 
   odnokorennyh slow *)
BEGIN
  IF TREE=NIL
    THEN
      ROOTFINDWORD:=NIL
    ELSE
      WITH TREE^ DO
	IF STRING=WORD
	  THEN
	    ROOTFINDWORD:=TREE
	  ELSE
	    BEGIN
	      ASSIGN(STRING,WORD);
	      CASE FIND OF
		FALSE : IF STRING<WORD
		          THEN
		            ROOTFINDWORD:=ROOTFINDWORD(LEFT,STRING)
			  ELSE
			    ROOTFINDWORD:=ROOTFINDWORD(RIGHT,STRING);
		TRUE  : ROOTFINDWORD:=TREE;
	      END
	    END
END;

PROCEDURE SORTING;
(* sortirowka wywodimyh na pe~atx slow 
   po wozrastani` s~et~ika *)

VAR
  JUMP : INTEGER;
  M,Q  : 1..TABLELENGTH;
  W    : TYPLINE;
  UP   : BOOLEAN;
BEGIN
  JUMP:=J;
  WHILE JUMP>=1 DO
    BEGIN
      JUMP:=JUMP DIV 2;
      REPEAT
	UP:=TRUE;
	FOR M:=1 TO J-JUMP DO
	  BEGIN
	    Q:=M+JUMP;
	    IF TABLE[M].COUNTER>TABLE[Q].COUNTER
	      THEN
		BEGIN
		  W:=TABLE[M];
		  TABLE[M]:=TABLE[Q];
		  TABLE[Q]:=W;
		  UP:=FALSE
		END
	  END
       UNTIL UP
    END
END;

PROCEDURE PRINTTABLE;
(* pe~atx tablicy slow, ne soderv. w sloware *)

VAR
  K : 1..TABLELENGTH;

BEGIN
  FOR K:=1 TO J DO
    BEGIN
      WITH TABLE[K] DO
	WRITE(OUF,WORD,COUNTER:5,' ':6);
      IF NOT ODD(K)
	THEN
	  WRITELN(OUF)
    END
END;


BEGIN	  (*MAIN*)
  LETTERS:=['j','c','u','k','e','n','g','{','}','z',
            'h','f','y','w','a','p','r','o','l','d',
            'v','|','q','~','s','m','i','t','x','b','`'];
  NILTREE;                    	                 (* iniciirowanie derewa *)
  CREATETREE(TREEWORD);              (* postroenie derewa slow iz slowarq *)
  WRITE('slowarx sodervit odnokorennye slowa?(Y,N) ');
  READLN(ANSWER);
  REPEAT
    WRITE('wa{ tekstowoj fajl? ');
    READLN(INPFNAME);
    RESET(INPF,INPFNAME,'DOC',LENFIL);
    IF LENFIL=-1
      THEN
	WRITELN('fajl   ',INPFNAME,'ne najden')
  UNTIL LENFIL#-1;
  REWRITE(OUF,'LP:');
  WRITELN(OUF,'   fajl   ',INPFNAME,':');
  WRITELN(OUF);
  WRITELN(OUF);
  J:=1;
  REPEAT
    READWORD(TRACKWORD);        (* s~itywanie slowa iz teksta *)
    IF I>3
      THEN
	BEGIN
	  CASE ANSWER OF
           'Y' : RESULT:=FINDWORD(TREEWORD[TRACKWORD[1]],TRACKWORD);
	   'N' : RESULT:=ROOTFINDWORD(TREEWORD[TRACKWORD[1]],TRACKWORD)
	  END;
          IF RESULT=NIL
	    THEN
	      BEGIN            (* zapolnenie tablicy *)
		TABLE[J].WORD:=TRACKWORD;
		K:=1;
		WHILE TABLE[J].WORD#TABLE[K].WORD DO
		  K:=K+1;
		IF K<J
		  THEN
		    TABLE[K].COUNTER:=TABLE[K].COUNTER+1
                  ELSE
		   BEGIN
		     J:=J+1;
		     TABLE[K].COUNTER:=1
		   END
	      END
	END
  UNTIL EOF(INPF);
  J:=J-1;
  SORTING;                      (* sortirowka *)
  PRINTTABLE;                   (* pe~atx tablicy na LP:*)
  CLOSE(OUF)
END.				        
